#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<algorithm>
#include<vector>
#include<list>
#include<string>
#include<set>
#include<map>
#include<cmath>
#include<memory.h>
#include<assert.h>
using namespace std;
typedef long long ll;
typedef long double ld;

const int N = 111;
const int V = N*N*2 + 5;
const int E = V*4;

int e[E*2], es[E*2];
int eb[V], ed;
ll ef[E*2], ec[E*2];

void init(int n){
    ed = 1;
    memset(eb, 0, n*sizeof(eb[0]));
}

void adde(int i, int j, int c){
    e[++ed] = j;
    ef[ed] = 0;
    ec[ed] = c;
    es[ed] = eb[i];
    eb[i] = ed;
    e[++ed] = i;
    ef[ed] = 0;
    ec[ed] = 0;
    es[ed] = eb[j];
    eb[j] = ed;
}


int o[V], d[V], fr[V];
bool bfs(int n, int S, int T, ll M){
    memset(d, 0, n*sizeof(d[0]));
    memset(fr, -1, n*sizeof(fr[0]));
    int m = 0;
    d[S] = 1;
    o[m++] = S;
    for(int l=0;l<m;++l){
        int v = o[l];
        for(int k=eb[v]; k; k=es[k]){
            int u = e[k];
            if(!d[u] && ec[k]-ef[k]>=M){
                d[u] = d[v]+1;
                fr[u] = k;
                o[m++] = u;
            }
        }
    }
    if(!d[T]) return false;
    for(int v=T; v!=S; v=e[fr[v]^1]) ef[fr[v]]+=M, ef[fr[v]^1]-=M;
    return true;
}

ll maxflow(int n, int S, int T){
    ll flow = 0;
    ll M = 1LL<<30;
    while(M>0){
        while(bfs(n,S,T,M)) flow+=M;
        M>>=1;
    }
    return flow;
}

char s[N][N];

void solve(){
    int n, m;
    int ax=-1, ay=-1, bx=-1, by=-1, cx=-1, cy=-1;
    scanf("%d%d",&n,&m);
    assert(1<=n && n<=100);
    assert(1<=m && m<=100);
    for(int i=0;i<n;++i){
        scanf("%s",&s[i]);
        for(int j=0;j<m;++j){
            assert(s[i][j]=='.' || s[i][j]=='#' || s[i][j]=='S' || s[i][j]=='C' || s[i][j]=='H');
            if(s[i][j]=='S') ax=i, ay=j, s[i][j]='.';
            if(s[i][j]=='C') bx=i, by=j, s[i][j]='.';
            if(s[i][j]=='H') cx=i, cy=j, s[i][j]='.';
        }
    }
    
    assert(ax!=-1);
    assert(bx!=-1);
    assert(cx!=-1);
    
    init(n*m*2 + 2);
    
    int dx[4] = {-1,0,1,0};
    int dy[4] = {0,-1,0,1};
    for(int i=0;i<n;++i)
    for(int j=0;j<m;++j){
        if(s[i][j]=='.'){
            int vin = (i*m+j)*2;
            int vout = vin+1;
            adde(vin, vout, 1);
            for(int k=0;k<4;++k){
                int x = i+dx[k];
                int y = j+dy[k];
                if(x<0 || y<0 || x>=n || y>=m || s[x][y]=='#') continue;
                adde(vout, (x*m+y)*2, 1); 
            }
        }
    }
    
    adde((ax*m+ay)*2+1, n*m*2+1, 1);
    adde((cx*m+cy)*2+1, n*m*2+1, 1);
    
    int flow = maxflow(n*m*2+2, (bx*m+by)*2+1, n*m*2+1);
    
    puts(flow>=2 ? "Yes" : "No");
}

int main(){
    //freopen("bizons.in","r",stdin);// freopen("output.txt","w",stdout);
    
    int t;
    scanf("%d",&t);
    while(t--) solve();

    
    
    return 0;
}

