import java.io.PrintWriter;
import java.util.Random;
import java.util.HashSet;

public class Currency_Tests
{
    public static void main(String[] args) throws Exception
    {
        new Currency_Tests().run(args);
    }

    private int tests;
    private int testn;
    PrintWriter out = null;
    Random rand = null;
    HashSet<String> hs = null;
    private final int MAX_LEN = 1000;

    private boolean printTest(int max_period, int max_diff, double price)
    {
        int period = rand.nextInt(max_period) + 2;

        String s = String.format("%d\n", period);

        for(int i = 0; i < period; i++) {
            double diff = rand.nextDouble();
            double USD_sell = rand.nextDouble() * price;
            if(USD_sell < 0.01)
                USD_sell = 0.01;
            double USD_buy = USD_sell + diff * max_diff;
            diff = rand.nextDouble();
            double HKD_sell = rand.nextDouble() * price;
            if(HKD_sell < 0.01)
                HKD_sell = 0.01;
            double HKD_buy = HKD_sell + diff * max_diff;

            s += String.format("%.2f %.2f %.2f %.2f\n", USD_buy, USD_sell, HKD_buy, HKD_sell);
        }

        if (tests < testn)
        {
            if (!hs.contains(s))
            {
                tests++;
                out.print(s);
                hs.add(s);
                return true;
            }
        }
        return false;
    }

    private void run(String[] args) throws Exception
    {
        if (args.length> 0)
            testn = Integer.parseInt(args[0]);
        else
            testn = 10000;
        tests = 0;

        hs = new HashSet<String>();

        rand = new Random(678901);

        out = new PrintWriter("currency.in");
        out.println(testn);

        out.println("4");
        out.println("2.00 1.00 10.00 9.00");
        out.println("2.75 2.50 5.90 1.20");
        out.println("1.00 0.80 10.00 2.00");
        out.println("6.50 5.00 9.50 8.50");
        tests++;

        while (tests < 10) {
            printTest(5, 2, 1);
        }

        out.println("2");
        out.println("1.00 1.00 1.00 1.00");
        out.println("2.00 1.01 1.00 0.99");
        tests++;

        out.println("4");
        out.println("1.00 1.00 1.00 1.00");
        out.println("10000.00 10000.00 10000.00 10000.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1000.00 1000.00 1000.00 1000.00");
        tests++;

        out.println("31");
        out.println("1.00 1.00 1.00 1.00");
        out.println("10.00 10.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 10.00 10.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("10.00 10.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 10.00 10.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("10.00 10.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("1.00 1.00 10.00 10.00");
        out.println("1.00 1.00 1.00 1.00");
        out.println("10.00 10.00 1.00 1.00");
        out.println("1.00 1.00 1.00 1.00");
        tests++;

        while (tests < 100) {
            printTest(5, 2, 5);
        }

        while (tests < 300) {
            printTest(10, 10, 10);
        }

        while (tests < 900) {
            printTest(30, 100, 90);
        }

        while (tests < testn) {
            printTest(30, 1000, 100);
        }

        out.close();
    }

}
