#include <cmath>
#include <ctime>
#include <vector>
#include <string>
#include <fstream>
#include <iostream>
#include <algorithm>
#include <limits.h>

const int MAX_N = 300;
const double ALPHA = .0;

std::string str[2];
double cost[MAX_N + 1][MAX_N + 1];

double Solve()
{
	for (int i = 1; i <= str[0].size(); i++)
	{
		for (int j = 1; j <= str[1].size(); j++)
		{
			cost[i][j] = str[0][i - 1] == str[1][j - 1] ? cost[i - 1][j - 1] : INT_MAX;
			for (int k = 0; k < i; k++)
			{
				cost[i][j] = std::min(cost[i][j], cost[k][j] + ALPHA + sqrt(i - k));
			}

			for (int k = 0; k < j; k++)
			{
				cost[i][j] = std::min(cost[i][j], cost[i][k] + ALPHA + sqrt(j - k));
			}
		}
	}

	return cost[str[0].size()][str[1].size()];
}

int main(int argc, char * argv[])
{
	int n;
	int m;
	int testNumber;	
	std::ifstream in("editor.in");
	in >> testNumber;
	cost[0][0] = 0;
	for (int i = 1; i <= MAX_N; i++)
	{
		cost[0][i] = ALPHA + sqrt(i);
		cost[i][0] = ALPHA + sqrt(i);
	}

	for (int t = 0; t < testNumber; t++)
	{
		in >> n >> m >> str[0] >> str[1];		
		if (n != str[0].size() || m != str[1].size() || n > MAX_N || m > MAX_N)
		{
			std::cout << "NOOOOOOOOOOOOOOOOOOO";
			abort();
		}

		std::cout.setf(std::cout.fixed);
		std::cout.precision(2);
		std::cout << Solve() << std::endl;
	}

	std::cerr << double(clock()) / CLOCKS_PER_SEC;
	return 0;
}