#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <memory.h>
#include <assert.h>
using namespace std;
typedef long long ll;


const int N = 11111;
const int S = 111;
const int inf = 2111111111;
const int lim = 1000000000;

int t1[S][N];
int t2[N][S];
int b[S][S];


#define upd(i) if(l<=i && i<=r){if(li!=-1) res=min(res, a[i]-a[li]); li=i;}
int K;
int ask(int l, int r, vector<int>&a){
    int res = inf;
    int kl = l/K, kr = r/K;
    if(kl==kr){
        int *p = b[kl];
        int li = -1;
        for(int i=0;i<K;++i) upd(p[i]);
    }else{
        res = min(t2[l][kr-1], t1[kl+1][r]);
        int li = -1;
        int *p1 = b[kl];
        int *p2 = b[kr];
        for(int i=0,j=0; i<K || j<K;){
            if(i<K && (j==K || a[p1[i]]<a[p2[j]])){
                upd(p1[i]);
                ++i;
            }else{
                upd(p2[j]);
                ++j;
            }
        }
    }
    return res;
}

int mx, mn, sz, pp;
vector<int> solve(vector<int> a, vector<pair<int,int>> &q){
    int n = a.size();
    K = sqrt(n);
    while(n%K) ++n;
    a.resize(n);
    
    for(int i=0;i<n;i+=K){
        int *c = b[i/K];
        for(int j=0;j<K;++j) c[j] = i+j;
        sort(c,c+K,[a](int i1, int i2){return a[i1]<a[i2];});
    }
    
    for(int i=0;i<n;i+=K){
        set<int> q;
        int res = inf;
        for(int j=i;j<n;++j){
            auto it = q.upper_bound(a[j]);
            if(it!=q.end()) res = min(res, *it-a[j]);
            if(it!=q.begin()){
                --it;
                res = min(res, a[j]-*it);
            }
            q.insert(a[j]);
            t1[i/K][j] = res;
        }
    }
    
    for(int j=K-1;j<n;j+=K){
        set<int> q;
        int res = inf;
        for(int i=j;i>=0;--i){
            auto it = q.upper_bound(a[i]);
            if(it!=q.end()) res = min(res, *it-a[i]);
            if(it!=q.begin()){
                --it;
                res = min(res, a[i]-*it);
            }
            q.insert(a[i]);
            t2[i][j/K] = res;
        }
    }
    
    vector<int> answers;
    int ans = 0;
    for(auto &z : q){
        int l = z.first, r = z.second;
        ans=ask(l,r,a);
        assert(ans>=0);
        answers.push_back(ans);
    }
    
    map<int,int> mp;
    for(int i : answers) mp[i]++;
    mn = mp.begin()->first;
    mx = mp.rbegin()->first;
    sz = mp.size();
    pp = 0;
    for(auto p : mp) pp=max(pp, p.second);
    
    return answers;
}



vector<pair<vector<int>,vector<pair<int,int>>>> t;
int tests;
int suma = 0, sumq = 0;
const int lima = 10000, limq = 100000;
const int limsuma = 50000, limsumq = 500000;

void add(vector<int> a, vector<pair<int,int>> q){
    suma+=a.size();
    sumq+=q.size();
    assert(suma<=limsuma);
    assert(sumq<=limsumq);
    t.push_back({a,q});
    ++tests;
}

int rnd(int l, int r){
    return rand()%(r-l+1) + l;
}

void make(){
    FILE *in = fopen("queries.in", "w");
    FILE *out = fopen("queries.out", "w");
    
    fprintf(in, "%d\n", tests);
    for(int i=0;i<tests;++i){
        vector<int> &a = t[i].first;
        int n = a.size();
        vector<pair<int,int>> &q = t[i].second;
        assert(2<=a.size() && a.size()<=lima);
        assert(1<=q.size() && q.size()<=limq);
        vector<int> res = solve(a, q);
        fprintf(in, "%d\n", (int)a.size());
        for(int i=0;i<a.size();++i){
            assert(-lim<=a[i] && a[i]<=lim);
            fprintf(in, "%s%d", (i?" ":""), a[i]);
        }
        fprintf(in,"\n");
        fprintf(in, "%d\n", (int)q.size());
        for(int k=0, ans=0;k<q.size();++k){
            assert(0<=q[k].first && q[k].first<q[k].second && q[k].second<n);
            fprintf(in, "%d %d\n", (q[k].first-ans%n+n)%n, (q[k].second-ans%n+n)%n);
            ans = res[k];
        }
        for(int x : res) fprintf(out, "%d\n", x);
        mn = *min_element(res.begin(), res.end());
        mx = *max_element(res.begin(), res.end());
        map<int,int> all;
        for(int x : res) all[x]++;
        pp = 0;
        vector<int> pv;
        for(auto x : all) pv.push_back(x.second);
        sort(pv.rbegin(), pv.rend());
        cerr<<i<<": "<<mn<<"..."<<mx<<"  "<<all.size()<<' ';
        for(int k=0;k<6;++k) cerr<<' '<<pv[k]; cerr<<endl;
    }
    
    fflush(in); fclose(in);
    fflush(out); fclose(out);
    
    cerr<<"====="<<endl;
    cerr<<"ok "<<tests<<' '<<suma<<' '<<sumq<<endl;
}


vector<int> rnda(int n){
    vector<int> a(n);
    for(int &x : a) x = rnd(-lim, lim);
    return a;
}

vector<pair<int,int>> rndq(int n, int m){
    vector<pair<int,int>> q(m);
    for(auto &p : q){
        int l,r;
        do{
            l = rnd(0,n-1);
            r = rnd(0,n-1);
        }while(l==r);
        if(l>r) swap(l,r);
        p = {l,r};
    }
    return q;
}

int main(){
    //freopen("input.txt","r",stdin);// freopen("output.txt","w",stdout);
    
    int seed = time(0);
    //seed = 1443616557;
    seed=288;
    srand(seed);
    cerr<<seed<<endl;
    
    add({1,10,2,5,-10,0}, {{0,1},{1,4},{0,5},{3,5}});
    add({7,7,7}, {{0,2}});
    
    
    if(01){
        ///good
        int n = 10000;
        vector<int> a(n);
        for(int i=0;i<n/2;++i){
            a[i] = (i*3)*(i*3);
            a[n-i-1] = (i*3+1)*(i*3+2);
        }
        vector<pair<int,int>> q;
        for(int i=0,j=n-1,k=1;k<n;++k){
            q.push_back({i,j});
            if(k&1) ++i; else --j;
        }
        for(int i=1;i<n/2;++i){
            q.push_back({n/2-1-i, n/2-1});
            q.push_back({n/2, n/2+i});
        }
        random_shuffle(q.begin(), q.end());
        for(auto p : rndq(n, 100000-rand()%10-q.size())) q.push_back(p);
        add(a, q);
    }
    
    
    for(int i=0;i<4;++i){
        vector<int> a = rnda(10000-rand()%10);
        int n = a.size();
        a[rand()%n] = lim;
        a[rand()%n] = -lim;
        vector<pair<int,int>> q = rndq(n, 100000-rand()%10-n-n);
        for(int j=0;j<n-1;++j) q.push_back({0,j+1});
        for(int j=0;j<n-1;++j) q.push_back({j,n-1});
        solve(a,q);
        if(pp>11000) --i; else{
            add(a,q);
            cout<<"!"<<i<<endl;
        }
    }
    
    make();
    
    return 0;
}

