#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cmath>

struct Point{
    long long x, y;
};

bool inside(Point l, Point r, Point p)
{
    return l.x*1ll*(r.y-p.y) + r.x*1ll*(p.y-l.y) + p.x*1ll*(l.y-r.y) <= 0;
}

using namespace std;

int main()
{
    freopen("hit.in", "r", stdin);
    // freopen("hit2.out", "w", stdout);

    int t;
    cin >> t;
    while(t--)
    {
        int i, j, n, m;
        cin >> n >> m;
        vector<Point> p(n);
        for(i = 0; i < n; i++)
            cin >> p[i].x >> p[i].y;
        int zero_id = 0;
        for(i = 1; i < n; i++)
            if(p[i].x < p[zero_id].x || (p[i].x == p[zero_id].x && p[i].y < p[zero_id].y))
                zero_id = i;
        Point zero = p[zero_id];
        rotate (p.begin(), p.begin() + zero_id, p.end());
        for(i = 0; i < n; i++)
        {
            p[i].x -= zero.x;
            p[i].y -= zero.y;
        }
        p.push_back(p[0]);
        vector<double> an(n + 1);
        for(i = 0; i < p.size(); i++)
            an[i] = atan2(p[i].y, p[i].x);
        if(an[1] >= an[2])
        {
            reverse(p.begin(), p.end());
            reverse(an.begin(), an.end());
        }
        for(i = 0; i < m; i++)
        {
            long long x, y;
            cin >> x >> y;
            x = x - zero.x;
            y = y - zero.y;
            bool found = false;
            double angle = atan2(y, x);
            for(j = 0; j < n; j++)
            {
                if(an[j] <= angle && angle <= an[j + 1])
                {
                    Point l = p[j];
                    Point r = p[j + 1];
                    Point p;
                    p.x = x;
                    p.y = y;
                    if(inside(r, l, p))
                    {
                        found = true;
                        break;
                    }
                }
            }
            if(found)
                cout << "Yeap" << endl;
            else
                cout << "Nope" << endl;
        }
    }

    return 0;
}

