#define _CRT_SECURE_NO_WARNINGS


#include <stdio.h>
#include <assert.h>
#include <math.h>
#include <iostream>
#include <fstream>
#include <algorithm> 

using namespace std;

double eps = 1e-9;

double f1(double x)
{
	return -pow(3.0, -x * x + 2 * x + 1) - x * x + 4 * x + 8;
}

double f2(double x)
{
	return sin(x) - x + 1;
}

double f1_f2(double x)
{
	return f1(x)-f2(x);
}

double root(double (f)(double x), double l, double r)
{
	while ((r - l) > eps)
	{
		double fl = f(l);
		double fr = f(r);
		double middle = (l + r) / 2;
		double fm = f(middle);
		if (fl*fm > 0) l = middle;
		else r = middle;
	}
	return l;
}

double integral(double (f)(double x), double l, double r)
{
	double s = 0, curs = 0;
	int parts = 10;
	do
	{
		s = curs;
		curs = 0;
		parts *= 2;

		double h = (r - l) / parts;
		for (int i = 1; i < parts; i++)
		{
			curs += f(l + h*i);
		}
		curs += f(l) / 2 + f(r) / 2;
		curs *= h;

	} while (fabs(s - curs) > eps);
	return curs;
}

int main()
{
	double x1 = root(f1, -2, 1);
	double x2 = root(f1_f2, -2, -1);
	double x3 = root(f2, 1, 3);
	


	double s = integral(f1, x1, x2) + integral(f2, x2, x3);

	freopen("integral.in", "r", stdin);
	//freopen("integral.out", "w", stdout);

	int test;
	cin >> test;
	
	for (int t = 0; t < test; t++)
	{
		double l, r;
		cin >> l >> r;

		assert(l < r);
		
		double res = 0;

		if (r < x1 || l > x3) res = 0;
		else
		{
			if (l < x2)	res += integral(f1, max(l, x1), min(x2, r));
			if (r > x2) res += integral(f2, max(l, x2), min(x3, r));
		}
		assert(res >= 0);
		printf("%.6lf\n", res);
		
	}

	return 0;
}