﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ACM2015
{
    class Joining
    {
        private static string line;
        private static int p;

        static void Main(string[] args)
        {
            using (var stream = File.OpenText("JOINING.IN"))
            {
                var tn = int.Parse(stream.ReadLine());
                Debug.Assert(tn >= 1 && tn <= 100);

                for (int ti = 0; ti < tn; ti++)
                {
                    var s = stream.ReadLine();
                    Debug.Assert(s.Length > 0 & s.Length <= 255);

                    line = s;
                    p = 0;

                    var ans = expr();
                    Debug.Assert(p == line.Length);
                    Console.WriteLine("{{{0}}}", string.Join("", ans.OrderBy(c => c).ToArray()));
                }
            }
        }

        private static HashSet<char> expr()
        {
            var result = simple_expr();
            while (p < line.Length && (line[p] == '+' || line[p] == '-'))
            {
                var op = line[p++];
                var add = simple_expr();

                if (op == '+')
                {
                    result.UnionWith(add);
                }
                else 
                {
                    result.ExceptWith(add);
                }
            }
            return result;
        }

        private static HashSet<char> simple_expr()
        {
            var result = atomic_expr();
            while (p < line.Length && line[p] == '*')
            {
                p++;
                var mult = atomic_expr();
                result.IntersectWith(mult);
            }
            return result;
        }

        private static HashSet<char> atomic_expr()
        {
            HashSet<char> result = null;
            if (line[p] == '{')
            {
                p++;
                result = new HashSet<char>();
                while (char.IsLetter(line[p]))
                {
                    Debug.Assert(line[p] >= 'A' && line[p] <= 'Z');
                    Debug.Assert(!result.Contains(line[p]));
                    result.Add(line[p]);
                    p++;
                }
                Debug.Assert(line[p] == '}');
                p++;
            }
            else if (line[p] == '(')
            {
                p++;
                result = expr();
                Debug.Assert(line[p] == ')');
                p++;
            }
            else
            {
                Debug.Assert(false);
            }
            return result;
        }
    }
}
