import java.io.*;
import java.util.*;

public class Kid 
{
	public static void main(String[] args) throws Exception
	{
		primes = getPrimes(10000);
	
		//new Kid().testsToFile();
		new Kid().run();
	}
	
	/*
	private boolean addTest(int a, int b, Vector<Pair> v, HashSet<Pair> hs)
	{
		Pair p = new Pair(a, b);
		if (hs.contains(p))
			return false;
		
		v.add(p);
		hs.add(p);
		return true;
	}
	
	private void testsToFile() throws Exception 
	{
		int testn = 10000;
		
		Vector<Pair> v = new Vector<Pair>();
		HashSet<Pair> hs = new HashSet<Pair>();
		
		// v.size = 4 
		addTest(2, 3, v, hs);
		addTest(9, 2, v, hs);
		addTest(9, 10, v, hs);
		addTest(10000, 9999, v, hs);
		
		
		int max_ab = 10;
		for (int a = 2; a <= max_ab; a++)
		{
			for (int b = 2; b <= max_ab; b++)
			{
				if (gcd(a, b) == 1)
				{
					addTest(a, b, v, hs);					
				}
			}
		}
		// v.size = 45
		
		int[] p10 = new int[] {10, 100, 1000, 10000};
		Random rand = new Random(852456);
		int[][] ab = new int[4][4];
		
		while (v.size() < 150)
		{
			int ai = rand.nextInt(p10.length);
			int bi = rand.nextInt(p10.length);
			
			int a = rand.nextInt(p10[ai]) + 1;
			int b = rand.nextInt(p10[bi]) + 1;
			if (a == 1 || b == 1 || gcd(a, b) != 1 || hs.contains(new Pair(a, b)))
				continue;
			
			if (addTest(a, b, v, hs))
			{
				ab[ai][bi]++;
			}
		}
		//v.size = 150
		
		for (int a = 10000; a >= 10000 - max_ab; a--)
		{
			for (int b = 10000; b >= 10000 - max_ab; b--)
			{
				if (gcd(a, b) == 1)
				{
					addTest(a, b, v, hs);					
				}
			}
		}
		// v.size = 215
		
		max_ab = 50;
		for (int a = 2; a <= max_ab; a++)
		{
			for (int b = 2; b <= max_ab; b++)
			{
				if (gcd(a, b) == 1)
				{
					addTest(a, b, v, hs);					
				}
			}
		}
		// v.size ~ 1600
		
		for (int a = 10000; a >= 10000 - max_ab; a--)
		{
			for (int b = 10000; b >= 10000 - max_ab; b--)
			{
				if (gcd(a, b) == 1)
				{
					addTest(a, b, v, hs);					
				}
			}
		}
		// v.size ~ 3000
		
		while (v.size() < 9000)
		{
			int ai = rand.nextInt(p10.length);
			int bi = rand.nextInt(p10.length);
			
			int a = rand.nextInt(p10[ai]) + 1;
			int b = rand.nextInt(p10[bi]) + 1;
			if (a == 1 || b == 1 || gcd(a, b) != 1 || hs.contains(new Pair(a, b)))
				continue;
			
			if (addTest(a, b, v, hs))
			{
				ab[ai][bi]++;
			}
		}
		
		while (v.size() < testn)
		{
			int ai = 3;
			int bi = 3;
			
			int a = rand.nextInt(p10[ai]) + 1;
			int b = rand.nextInt(p10[bi]) + 1;
			if (a == 1 || b == 1 || gcd(a, b) != 1 || hs.contains(new Pair(a, b)))
				continue;
			
			if (addTest(a, b, v, hs))
			{
				ab[ai][bi]++;
			}
		}
		
		for (int i = 0; i < 4; i++)
		{
			for (int j = 0; j < 4; j++)
			{
				System.out.print(ab[i][j] + " ");				
			}
			System.out.println();
		}
		
		PrintWriter out = new PrintWriter("kid.in");
		out.println(v.size());
		for (int i = 0; i < v.size(); i++)
		{
			Pair p = v.get(i);
			out.println(p.first + " " + p.second);
		}
		out.close();
		
	}
	 */
	
	public class Pair
	{
		public int first;
		public int second;
		public Pair()
		{
			first = 0;
			second = 0;
		}
		
		public Pair(int f, int s)
		{
			first = f;
			second = s;
		}
		
		@Override
		public boolean equals(Object obj) {
			Pair p = (Pair)obj;
			return p.first == first && p.second == second;
		}
		
		@Override
		public String toString() {
			return first + " " + second;
		}
		
		@Override
		public int hashCode() {
			return first * second;
		}
	}

	private static int[] getPrimes(int n)
	{
		boolean[] composite = new boolean[n + 1];
		
		for (int i = 3; i * i <= n; i += 2)
		{
			if (!composite[i])
			{
				if (i * i <= n)
				{
					for (int j = i * i; j <= n; j += i)
					{
						composite[j] = true;
					}
				}
			}
		}
		
		Vector<Integer> ans = new Vector<Integer>();
		ans.add(2);
		for (int i = 3; i <= n; i += 2)
		{
			if (!composite[i])
				ans.add(i);
		}
		
		int[] primes = new int[ans.size()];
		for (int i = 0; i < ans.size(); i++)
		{
			primes[i] = ans.get(i).intValue();
		}
		return primes;
	}
	
	private static int[] primes;
	
	private static int module = 1000 * 1000 * 1000 + 7;
	
	private long solve1(int a, int b)
	{
		Pair[] afact = fact(a);
		Pair[] bfact = fact(b);
		
		Vector<Pair> ansFact = new Vector<Pair>(); 
		
		int max = 0; // validation
		
		for (int ai = 0; ai < afact.length; ai++)
		{
			int curpow = afact[ai].second;
			
			int power1 = powerAdd(curpow, 0, a, b);
			
			// validatoin 
			{
				int power2 = powerMult(curpow, 0, a, b);
				if (power1 != power2)
					throw new RuntimeException();
				
				if (power1 % b != 0)
					throw new RuntimeException();
				if ((power1 - curpow) % a != 0)
					throw new RuntimeException();
			
				int all = (power1 - curpow) / a;
				int arr = power1 / b;
				
				if (Math.max(all, arr) > max)
					max = Math.max(all, arr);
			}
			
			ansFact.add(new Pair(afact[ai].first, power1));
		}
		
		for (int bi = 0; bi < bfact.length; bi++)
		{
			int curpow = bfact[bi].second;
			
			int power1 = powerAdd(0, curpow, a, b);
			
			// validatoin 
			{
				int power2 = powerMult(0, curpow, a, b);
				if (power1 != power2)
					throw new RuntimeException();
				
				if (power1 % a != 0)
					throw new RuntimeException();
				if ((power1 - curpow) % b != 0)
					throw new RuntimeException();
			
			
				int bll = power1 / a;
				int brr = (power1 - curpow) / b;
				
				if (Math.max(bll, brr) > max)
					max = Math.max(bll, brr);
			}
			
			ansFact.add(new Pair(bfact[bi].first, power1));
		}
		
		// validatoin 
		{
			if (max >= Math.max(a, b))
				throw new RuntimeException();
		}
		
		
		long ans = 1;
		for (int i = 0; i < ansFact.size(); i++)
		{
			Pair pow = ansFact.get(i);
			ans *= binpow(pow.first, pow.second, module);
			ans %= module;
		}

		return ans;
	}
	
	private long solve2(int a, int b)
	{
		Pair[] afact = fact(a);
		Pair[] bfact = fact(b);
		
		Vector<Pair> ansFact = new Vector<Pair>(); 
		
		Pair gcdExt = gcdExt(a, b);
		
		int max = 0; // validation
		
		for (int ai = 0; ai < afact.length; ai++)
		{
			int curpow = afact[ai].second;
			int x0 = gcdExt.first * curpow;
			int y0 = gcdExt.second * curpow;
			
			x0 *= -1;
			
			// validation
			{
				if (-a*x0 + b*y0 != curpow)
					throw new RuntimeException();
			}
			
			Pair res = bs(a, b, x0, y0);
			int power1 = curpow + a*res.first;
			
			// validatoin 
			{
				int power2 = b*res.second;
				if (power1 != power2)
					throw new RuntimeException();
				
				if (Math.max(res.first, res.second) > max)
					max = Math.max(res.first, res.second);
			}
			
			ansFact.add(new Pair(afact[ai].first, power1));
		}
		
		for (int bi = 0; bi < bfact.length; bi++)
		{
			int curpow = bfact[bi].second;
			
			int x0 = gcdExt.first * curpow;
			int y0 = gcdExt.second * curpow;
			
			y0 *= -1;
			
			// validation
			{
				if (a*x0 - b*y0 != curpow)
					throw new RuntimeException();
			}
			
			Pair res = bs(a, b, x0, y0);
			int power1 = a*res.first;
			
			// validatoin 
			{
				int power2 = curpow + b*res.second;
				if (power1 != power2)
					throw new RuntimeException();
				
				if (Math.max(res.first, res.second) > max)
					max = Math.max(res.first, res.second);
			}
			
			ansFact.add(new Pair(bfact[bi].first, power1));
		}
		
		// validatoin 
		{
			if (max >= Math.max(a, b))
				throw new RuntimeException();
		}
		
		
		long ans = 1;
		for (int i = 0; i < ansFact.size(); i++)
		{
			Pair pow = ansFact.get(i);
			ans *= binpow(pow.first, pow.second, module);
			ans %= module;
		}

		return ans;
	}
	
	private Pair bs(int a, int b, int x0, int y0)
	{
		int l = -1;
		while ((x0 + l*b) >= 0 || (y0 + l*a) >= 0)
		{
			l *= 2;
		}
		
		int r = 1;
		while ((x0 + r*b) < 0 || (y0 + r*a) < 0)
		{
			r *= 2;
		}
		
		while (r - l > 1)
		{
			int m = (l + r) / 2;
			if ((x0 + m*b) >= 0 && (y0 + m*a) >= 0)
				r = m;
			else
				l = m;
		}
		
		return new Pair(x0 + r*b, y0 + r*a);
	}
	
	private Pair gcdExt(int a, int b) 
	{
		if (a == 0) 
			return new Pair(0, 1);
		
		Pair p = gcdExt (b % a, a);
		return new Pair(p.second - (b / a) * p.first, p.first);
	}
	
	private long binpow(long a, int n, int mod) 
	{
		long res = 1L;
		while (n > 0) 
		{
			if (n % 2 == 1)
			{
				res *= a;
				res %= mod;
			}
			a *= a;
			a %= mod;
			
			n /= 2;
		}
		return res;
	}
	
	private Pair[] fact(int n)
	{
		Vector<Pair> res = new Vector<Pair>();
		
		for (int i = 0; i < primes.length; i++)
		{
			if (n == 1 || primes[i] * primes[i] > n)
				break;
			
			int power = 0;
			while (n % primes[i] == 0)
			{
				power++;
				n /= primes[i]; 
			}
			
			if (power > 0)
			{
				res.add(new Pair(primes[i], power));
			}
		}
		
		if (n > 1)
		{
			res.add(new Pair(n, 1));
		}
		
		return res.toArray(new Pair[1]);
	}
	
	private int gcd(int a, int b) 
	{
		while (b > 0) 
		{
			a %= b;
			int temp = a;
			a = b;
			b = temp;
		}
		return a;
	}
	
	private void run() throws Exception
	{
		Scanner in = new Scanner(new File("kid.in"));
		PrintWriter out = new PrintWriter(System.out);
		//PrintWriter out = new PrintWriter("kid.out");
		
		int testn = in.nextInt();
		for (int testi = 0; testi < testn; testi++)
		{
			int a = in.nextInt();
			int b = in.nextInt();
			
			// validation
			{
				checkBounds(a, 2, 10000);
				checkBounds(b, 2, 10000);
				if (gcd(a, b) != 1)
					throw new RuntimeException();
			}
			long ans1 = solve1(a, b);
			long ans2 = solve2(a, b);
			if (ans1 != ans2)
				throw new RuntimeException();
			out.println(ans1);
		}
		
		in.close();
		out.close();
	}
	
	private void checkBounds(int value, int min, int max)
	{
		if (value < min || value > max)
			throw new RuntimeException();
	}

	private int powerMult(int l, int r, int dl, int dr) 
	{
		while (l != r)
		{
			int diff = Math.abs(l - r);
			if (l < r)
			{
				int mult = diff / dl;
				l += dl*mult;
				if (l < r)
					l += dl;
			}
			else
			{
				int mult = diff / dr;
				r += dr*mult;
				if (r < l)
					r += dr;
			}
		}
		return l;
	}
	
	private int powerAdd(int pl, int pr, int a, int b)
	{
		while (pl != pr)
		{
			if (pl < pr)
			{
				pl += a;
			}
			else
			{
				pr += b;
			}
		}
		return pr;
	}
}
